Synnefo - Bug # 3479

Status: Closed Priority: High

Author: Georgios Tsoukalas Category: Astakos
Created: 03/21/2013 Assignee: Giorgos Korfiatis
Updated: 03/28/2013 Due date:

Subject: Database stack limit reached in retrieving quota for all users

Description

From the logs:

...astakos.im.management.commands.astakos-quota astakos-quota [ERROR] stack depth limit exceeded
HINT: Increase the configuration parameter "max_stack_depth", after ensuring the platform's stack depth limit is adequate.

The server setting was the default:
#max_stack_depth = 2MB # min 100kB

The query was of the form:
SELECT ... WHERE (a=... AND b=...) OR (a=... AND b=...) ... FOR UPDATE.

The number of OR terms was around 15800.
It seems that during the parsing of the statement the OR-tree is not optimized into a flat structure,
and the resulting depth causes the recursion to reach the stack limit.

The query form is a result of repeated Qall |= Qx Django queryset calls.

The efficient SQL query can be expressed in the form:
SELECT ... WHERE (a, b) in ((..., ...), ...) FOR UPDATE.

However the Django __in notation cannot express the (a, b) part of the syntax
even though it can express the right-hand list of tuples.

Associated revisions

Revision 2f906450 - 03/21/2013 05:42 pm - Giorgos Korfiatis
Simplify query to avoid hitting db stack limit

Refs #3479

Looking up (entity, resource) pairs created a huge query formula

in disjunctive normal form, which apparently brought the db parser

to its limits.

It has been replaced by selecting the holdings by entity only.

This means that in theory we lock more holdings than needed (for any
resource for a given entity), but in practice we would need to

select these holdings anyway.

Revision 6950864 - 03/21/2013 06:04 pm - Giorgos Korfiatis

Sync only quotas that differ
Refs #3479
Database stack limit issue was triggered by syncing quotas for

all users. It is much faster to compare quotas locally and send

for sync to quotaholder only those that differ.

History

#1 - 03/26/2013 01:06 pm - Giorgos Korfiatis
- Status changed from New to Resolved

#2 - 03/28/2013 11:50 am - Georgios Tsoukalas
- Status changed from Resolved to Closed
